#! /usr/bin/python
"""
%s [<>] <> <   > 

:
	-h	 
	-v	
	-i	   
	-m	    
	-u	 HTTP/1.1
	-s	       
	--ign	 
	--all	 
"""

import socket
import posix
import re
import string
import rand
import sys
import getopt
import md5
import time

verbose_level		= 0
is_incomplete		= 0
sleep			= 60
ignored			= ['Date']
http_version		= 'HTTP/1.0'
(err_body1,err_hdr1)	= (0,0)
(err_body2,err_hdr2)	= (0,0)
http_error1		= 0
http_error2		= 0
notmodify1		= 0
notmodify2		= 0
is_cond			= 0
HttpError		= ' HTTP-'
NotModified		= '       '

def verbose(msg,level=1) :
	"""    """
	if level <= verbose_level :
		sys.stdout.write(msg + "\n")
		sys.stdout.flush()	

def error(msg,err=0) :
	"""       """
	if err :
		sys.stdout.write(": %s\n" % msg)
	else :
		sys.stdout.write("%s\n**   **\n" % msg)

	sys.stdout.flush()
	sys.exit(err)

hdrs_reg = re.compile('^([^:]*):')
def http_load(item,last_modified=None) :
	item = string.strip(item)
	verbose('\n %s' % item, 2)
	hdrs = {}
	sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
	sock.connect('okf.bpn.iig',80)
	f = sock.makefile('r+',1)
	f.write('GET http://%s/%s %s\n' % (args[0],string.strip(item),http_version))
#	print 'GET http://%s/%s %s\n' % (args[0],string.strip(item),http_version)
	if last_modified :
		f.write('If-Modified-Since: %s\n' % last_modified)
#		print 'If-Modified-Since: %s\n' % last_modified
	f.write('\n')
	
	size = None
	s=f.readline()
#	print s
	try :
		http_res = int(string.split(s)[1])
	except :
		raise HttpError

	if http_res != 200 :
		if http_res == 304 :
			verbose(': %s NotModified' % item,1)
			raise	NotModified
		else :
			verbose(' %s %u' % (item,http_res),1)
			raise	HttpError
		
	while len(s) : # , 
		if s == '\r\n' :
			if size :
				verbose('  URL  %u' % size,4)
				if is_incomplete :
					size_load = int(size * float(rand.rand())/(2**15-1))
				else :
					size_load = size

				body = f.read(size_load)
				verbose(' %u  %u (%u)' % (size_load,size,len(body)),4)
				break
			else :
				verbose('  ,    ',4)
				body = ""
				while 1 :
					s = f.read(512)
					if not s :
						break
					body = body + s
				break
					
		else :
			m = hdrs_reg.match(s)
			if m :
				(b,e) = m.regs[1]
				h = s[b:e]
				s = string.strip(s)
				hdrs[h] = s
				if h == 'Content-Length' :
					size = int(string.split(s)[1])
				verbose('  %s (%s)' % (h,s),5)
		s=f.readline()

	sock.close()
	return (string.join(map(lambda x : hex(ord(x))[2:4],md5.md5(body).digest()),''),hdrs)

def header_cmp(h_old,h_new) :
	res = 0
	for item in h_old.keys() :
		if item not in ignored :
			try :
				if h_old[item] != h_new[item] :
					res = res + 1
					verbose('   %s\n -- %s\n -- %s' % (item,h_old[item],h_new[item]),3)
			except KeyError :
				res = res + 1
				verbose('      %s' % h_old[item],3)

	for item in h_new.keys() :
		if item not in ignored :
			if not h_old.has_key(item) :
				res = res + 1
				verbose('       %s' % h_new[item],3)
			
	return res

opts,args = getopt.getopt(sys.argv[1:],"huvims:",['ign=','all'])
for opt,val in opts :
	if opt == '-h' :
		print __doc__ % sys.argv[0]
		error('      ')
	elif opt == '-v' :
		verbose_level = verbose_level + 1
	elif opt == '-i' :
		verbose('    ',1)
		is_incomplete = 1
	elif opt == '-m' :
		verbose('    ',1)
		is_cond	= 1
	elif opt == '-u' :
		verbose('  HTTP/1.1',1)
		http_version = 'HTTP/1.1'
	elif opt == '-s' :
		sleep = string.atoi(val)
		verbose(' %u ' % sleep,1)
	elif opt == '--all' :
		ignored = []
		verbose('  ',1)
	elif opt == '--ign' :
		ignored.append(val)
		verbose('  %s' % val,1)


if len(args) != 2 :	error('  ')

verbose('',0)
verbose('    ',1)
urlmd5 = {}

for item in open(args[1]).readlines() :
	try :
		(body,hdrs) = http_load(item)
		if is_cond :
			try :
				urlmd5[item] = (body,hdrs,string.strip(hdrs['Last-Modified'][len('Last-Modified:'):]))
			except KeyError :
				verbose('  Last-Modified -    ',2)
				urlmd5[item] = (body,hdrs)
		else :
			urlmd5[item] = (body,hdrs)
	except (HttpError,NotModified) :
		verbose('    %s' % item,1)
		http_error1 = http_error1 + 1


verbose(' %u ' % sleep,1)
time.sleep(sleep)
verbose('    ',1)
for item in urlmd5.keys() :
#	try :
		if is_cond and len(urlmd5[item]) == 3 :
			last_modify = urlmd5[item][2]
		else :
			last_modify = None

		try :
			(body,hdrs) = http_load(item,last_modify)
			if body != urlmd5[item][0] :
				err_body1 = err_body1 + 1
				verbose('          %s' % item,2)

			if header_cmp(urlmd5[item][1],hdrs) :
				err_hdr1 = err_hdr1 + 1
				verbose('           %s' % item,2)

			urlmd5[item] = (body,hdrs)

		except NotModified :
			notmodify1 = notmodify1 + 1
			verbose(' %s   ' % item, 2)


		try :
			(body,hdrs) = http_load(item,last_modify)
			if body != urlmd5[item][0] :
				err_body2 = err_body2 + 1
				verbose('          %s' % item,2)

			if header_cmp(urlmd5[item][1],hdrs) :
				err_hdr2 = err_hdr2 + 1
				verbose('           %s' % item,2)

		except NotModified :
			notmodify2 = notmodify2 + 1
			verbose(' %s   ' % item, 2)

#	except HttpError :
#		verbose('    %s' % item,1)
#		http_error2 = http_error2 + 1

verbose(' ',0)
verbose('----------------------',0)
verbose(' HTTP    %u' % http_error1)
verbose('    (,) (%u,%u)' % (err_body1,err_hdr1),0)
verbose('    (,) (%u,%u)' % (err_body2,err_hdr2),0)
verbose('     %u' % notmodify1, 0)
verbose('     %u' % notmodify2, 0)
verbose(' HTTP    %u' % http_error2)
verbose('----------------------',0)
